###
### libpcap
###
AC_ARG_WITH([libpcap], AC_HELP_STRING([--with-libpcap=DIR], [libpcap installation path]), [], [ withval="yes" ])

# additional -I flags needed for compilation
libpcap_cflags=""

# additional -l flags needed for linking
libpcap_libs=""

# additional -L flags needed for linking
libpcap_ldpath=""

# additional libtool objects
libpcap_libadd=""

AC_DEFUN([MYAC_CHECK_LIBPCAP],
    AC_LINK_IFELSE(
AC_LANG_PROGRAM(
[[
#include <pcap.h>
]],
[[
pcap_t *p = pcap_open_offline(0, 0);
]]
)
    ,
    AC_MSG_RESULT([-lpcap])
    AC_DEFINE([HAVE_PCAP], [1], [Define to 1 if libpcap works.])
    ,
    AC_MSG_FAILURE([cannot find libpcap library])
    libpcap_cflags=""
    libpcap_libs=""
    libpcap_ldpath=""
    libpcap_libadd=""
    )
)

AC_MSG_CHECKING([for libpcap headers])
libpcap_dir=""
if test "$withval" = "yes"; then
    withval="/usr /usr/local"
fi
for dir in $withval; do
    if test -f "$dir/include/pcap.h"; then
        found_libpcap_dir="yes"
        libpcap_dir="$dir"
        if test "$dir" != "/usr"; then
            libpcap_cflags="-I$dir/include"
        fi
        break
    fi
done

if test "$found_libpcap_dir" = "yes"; then
    AC_MSG_RESULT([$dir])
else
    AC_MSG_ERROR([cannot find pcap.h in $withval])
fi

AC_MSG_CHECKING([for libpcap library])

if test "$libpcap_dir" != "/usr"; then
    libpcap_ldpath="-L$libpcap_dir/lib"
fi

libpcap_libs="-lpcap"

save_cflags="$CFLAGS"
save_ldflags="$LDFLAGS"
save_libs="$LIBS"
CFLAGS="$CFLAGS $libpcap_cflags"
LDFLAGS="$LDFLAGS $libpcap_ldpath"
LIBS="$LIBS $libpcap_libs"

MYAC_CHECK_LIBPCAP

CFLAGS="$save_cflags"
LDFLAGS="$save_ldflags"
LIBS="$save_libs"

libpcap_ldflags="$libpcap_ldpath $libpcap_libs"

AC_SUBST([libpcap_cflags])  # add to _CFLAGS
AC_SUBST([libpcap_ldflags]) # add to _LDFLAGS
