###
### libprotobuf-c
###
AC_ARG_WITH([libprotobuf_c], AC_HELP_STRING([--with-libprotobuf_c=DIR], [libprotobuf_c installation path]), [], [ withval="yes" ])

use_internal_libprotobuf_c="false"

internal_cflags="-I$ac_abs_top_srcdir/protobuf-c"
internal_libadd="$ac_abs_top_srcdir/protobuf-c/google/protobuf-c/libprotobuf-c.la"

# additional -I flags needed for compilation
libprotobuf_c_cflags=""

# additional -l flags needed for linking
libprotobuf_c_libs=""

# additional -L flags needed for linking
libprotobuf_c_ldpath=""

# additional libtool objects
libprotobuf_c_libadd=""

AC_DEFUN([MYAC_CHECK_LIBPROTOBUF_C],
    AC_LINK_IFELSE(
AC_LANG_PROGRAM(
[[
#include <google/protobuf-c/protobuf-c.h>
]],
[[
ProtobufCMessage *m = protobuf_c_message_unpack(NULL, NULL, 0, NULL);
ProtobufCMessageDescriptor desc;
desc.message_init = NULL;
]]
)
    ,
    AC_MSG_RESULT([-lprotobuf-c])
    AC_DEFINE([HAVE_PROTOBUF_C], [1], [Define to 1 if libprotobuf_c works.])
    ,
    do_use_internal_protobuf_c
    )
)

do_use_internal_protobuf_c()
{
    use_internal_libprotobuf_c="true"

    AC_MSG_RESULT([using internal libprotobuf_c])
    AC_DEFINE([USE_INTERNAL_LIBPROTOBUF_C], [1], [Define to 1 to use internal libprotobuf_c.])
    libprotobuf_c_cflags="$internal_cflags"
    libprotobuf_c_libadd="$internal_libadd"
    libprotobuf_c_libs=""
    libprotobuf_c_ldpath=""
}

if test "$withval" = "no"; then
    do_use_internal_protobuf_c
fi

if test "$withval" != "no"; then
    AC_MSG_CHECKING([for libprotobuf-c headers])

    use_internal_libprotobuf_c="false"
    libprotobuf_c_libs="-lprotobuf-c"

    if test "$withval" = "yes"; then
        withval="/usr /usr/local"
    fi

    libprotobuf_c_dir=""
    for dir in $withval; do
        if test -f "$dir/include/google/protobuf-c/protobuf-c.h"; then
            found_libprotobuf_c_dir="yes"
            libprotobuf_c_dir="$dir"
            if test "$dir" != "/usr"; then
                libprotobuf_c_cflags="-I$dir/include"
            fi
            break
        fi
    done

    if test "$found_libprotobuf_c_dir" = "yes"; then
        AC_MSG_RESULT([$dir/include])

        AC_MSG_CHECKING([for libprotobuf-c library])

        if test "$libprotobuf_c_dir" != "/usr"; then
            libprotobuf_c_ldpath="-L$libprotobuf_c_dir/lib"
        fi

        save_cflags="$CFLAGS"
        save_ldflags="$LDFLAGS"
        save_libs="$LIBS"
        CFLAGS="$CFLAGS $libprotobuf_c_cflags"
        LDFLAGS="$LDFLAGS $libprotobuf_c_ldpath"
        LIBS="$LIBS $libprotobuf_c_libs"

        MYAC_CHECK_LIBPROTOBUF_C

        CFLAGS="$save_cflags"
        LDFLAGS="$save_ldflags"
        LIBS="$save_libs"
    else
        do_use_internal_protobuf_c
    fi
fi

libprotobuf_c_ldflags="$libprotobuf_c_ldpath $libprotobuf_c_libs"

AC_SUBST([libprotobuf_c_cflags])  # add to _CFLAGS
AC_SUBST([libprotobuf_c_ldflags]) # add to _LDFLAGS
AC_SUBST([libprotobuf_c_libadd])  # add to _LIBADD

AM_CONDITIONAL([INTERNAL_LIBPROTOBUF_C], [test "$use_internal_libprotobuf_c" = "true"])
