###
### libustr
###
AC_ARG_WITH([libustr], AC_HELP_STRING([--with-libustr=DIR], [libustr installation path]), [], [ withval="yes" ])

use_internal_libustr="false"

internal_cflags="-I$ac_abs_top_srcdir/ustr"
internal_libadd="$ac_abs_top_srcdir/ustr/libustr.la"

# additional -I flags needed for compilation
libustr_cflags=""

# additional -l flags needed for linking
libustr_libs=""

# additional -L flags needed for linking
libustr_ldpath=""

# additional libtool objects
libustr_libadd=""

AC_DEFUN([MYAC_CHECK_LIBUSTR],
    AC_LINK_IFELSE(
AC_LANG_PROGRAM(
[[
#include <ustr.h>
]],
[[
struct Ustr *s = ustr_dup_empty();
]]
)
    ,
    AC_MSG_RESULT([-lustr])
    AC_DEFINE([HAVE_USTR], [1], [Define to 1 if libustr works.])
    ,
    do_use_internal_ustr
    )
)

do_use_internal_ustr()
{
    use_internal_libustr="true"

    AC_MSG_RESULT([using internal libustr])
    AC_DEFINE([USE_INTERNAL_LIBUSTR], [1], [Define to 1 to use internal libustr.])
    libustr_cflags="$internal_cflags"
    libustr_libadd="$internal_libadd"
    libustr_libs=""
    libustr_ldpath=""
}

if test "$withval" = "no"; then
    do_use_internal_ustr
fi

if test "$withval" != "no"; then
    AC_MSG_CHECKING([for libustr headers])

    use_internal_libustr="false"
    libustr_libs="-lustr"

    if test "$withval" = "yes"; then
        withval="/usr /usr/local"
    fi

    libustr_dir=""
    for dir in $withval; do
        if test -f "$dir/include/ustr.h"; then
            found_libustr_dir="yes"
            libustr_dir="$dir"
            if test "$dir" != "/usr"; then
                libustr_cflags="-I$dir/include"
            fi
            break
        fi
    done

    if test "$found_libustr_dir" = "yes"; then
        AC_MSG_RESULT([$dir/include])

        AC_MSG_CHECKING([for libustr library])

        if test "$libustr_dir" != "/usr"; then
            libustr_ldpath="-L$libustr_dir/lib"
        fi

        save_cflags="$CFLAGS"
        save_ldflags="$LDFLAGS"
        save_libs="$LIBS"
        CFLAGS="$CFLAGS $libustr_cflags"
        LDFLAGS="$LDFLAGS $libustr_ldpath"
        LIBS="$LIBS $libustr_libs"

        MYAC_CHECK_LIBUSTR

        CFLAGS="$save_cflags"
        LDFLAGS="$save_ldflags"
        LIBS="$save_libs"
    else
        do_use_internal_ustr
    fi
fi

libustr_ldflags="$libustr_ldpath $libustr_libs"

AC_SUBST([libustr_cflags])  # add to _CFLAGS
AC_SUBST([libustr_ldflags]) # add to _LDFLAGS
AC_SUBST([libustr_libadd])  # add to _LIBADD

AM_CONDITIONAL([INTERNAL_LIBUSTR], [test "$use_internal_libustr" = "true"])
