###
### libwdns
###
AC_ARG_WITH([libwdns], AC_HELP_STRING([--with-libwdns=DIR], [libwdns installation path]), [], [ withval="yes" ])

use_internal_libwdns="false"

internal_cflags="-I$ac_abs_top_srcdir/wreck"
internal_libadd="$ac_abs_top_srcdir/wreck/wdns/msg/libwdns_msg.la"

# additional -I flags needed for compilation
libwdns_cflags=""

# additional -l flags needed for linking
libwdns_libs=""

# additional -L flags needed for linking
libwdns_ldpath=""

# additional libtool objects
libwdns_libadd=""

AC_DEFUN([MYAC_CHECK_LIBWDNS],
    AC_LINK_IFELSE(
AC_LANG_PROGRAM(
[[
#include <wdns.h>
]],
[[
char *s;
wdns_message_t m;
wdns_msg_status status;

status = wdns_parse_message(&m, NULL, 0);
s = wdns_message_to_str(&m);
]]
)
    ,
    AC_MSG_RESULT([-lwdns])
    AC_DEFINE([HAVE_WDNS], [1], [Define to 1 if libwdns works.])
    ,
    do_use_internal_wdns
    )
)

do_use_internal_wdns()
{
    use_internal_libwdns="true"

    AC_MSG_RESULT([using internal libwdns])
    AC_DEFINE([USE_INTERNAL_LIBWDNS], [1], [Define to 1 to use internal libwdns.])
    libwdns_cflags="$internal_cflags"
    libwdns_libadd="$internal_libadd"
    libwdns_libs=""
    libwdns_ldpath=""
}

if test "$withval" = "no"; then
    do_use_internal_wdns
fi

if test "$withval" != "no"; then
    AC_MSG_CHECKING([for libwdns headers])

    use_internal_libwdns="false"
    libwdns_libs="-lwdns"

    if test "$withval" = "yes"; then
        withval="/usr /usr/local"
    fi

    libwdns_dir=""
    for dir in $withval; do
        if test -f "$dir/include/wdns.h"; then
            found_libwdns_dir="yes"
            libwdns_dir="$dir"
            if test "$dir" != "/usr"; then
                libwdns_cflags="-I$dir/include"
            fi
            break
        fi
    done

    if test "$found_libwdns_dir" = "yes"; then
        AC_MSG_RESULT([$dir/include])

        AC_MSG_CHECKING([for libwdns library])

        if test "$libwdns_dir" != "/usr"; then
            libwdns_ldpath="-L$libwdns_dir/lib"
        fi

        save_cflags="$CFLAGS"
        save_ldflags="$LDFLAGS"
        save_libs="$LIBS"
        CFLAGS="$CFLAGS $libwdns_cflags"
        LDFLAGS="$LDFLAGS $libwdns_ldpath"
        LIBS="$LIBS $libwdns_libs"

        MYAC_CHECK_LIBWDNS

        CFLAGS="$save_cflags"
        LDFLAGS="$save_ldflags"
        LIBS="$save_libs"
    else
        do_use_internal_wdns
    fi
fi

libwdns_ldflags="$libwdns_ldpath $libwdns_libs"

AC_SUBST([libwdns_cflags])  # add to _CFLAGS
AC_SUBST([libwdns_ldflags]) # add to _LDFLAGS
AC_SUBST([libwdns_libadd])  # add to _LIBADD

AM_CONDITIONAL([INTERNAL_LIBWDNS], [test "$use_internal_libwdns" = "true"])
