###
### libz
###
AC_ARG_WITH([libz], AC_HELP_STRING([--with-libz=DIR], [libz installation path]), [], [ withval="yes" ])

# additional -I flags needed for compilation
libz_cflags=""

# additional -l flags needed for linking
libz_libs=""

# additional -L flags needed for linking
libz_ldpath=""

# additional libtool objects
libz_libadd=""

AC_DEFUN([MYAC_CHECK_LIBZ],
    AC_LINK_IFELSE(
AC_LANG_PROGRAM(
[[
#include <zlib.h>
]],
[[
inflateInit(0);
]]
)
    ,
    AC_MSG_RESULT([-lz])
    AC_DEFINE([HAVE_Z], [1], [Define to 1 if libz works.])
    ,
    AC_MSG_FAILURE([cannot find libz library])
    libz_cflags=""
    libz_libs=""
    libz_ldpath=""
    libz_libadd=""
    )
)

AC_MSG_CHECKING([for libz headers])
libz_dir=""
if test "$withval" = "yes"; then
    withval="/usr /usr/local"
fi
for dir in $withval; do
    if test -f "$dir/include/zlib.h"; then
        found_libz_dir="yes"
        libz_dir="$dir"
        if test "$dir" != "/usr"; then
            libz_cflags="-I$dir/include"
        fi
        break
    fi
done

if test "$found_libz_dir" = "yes"; then
    AC_MSG_RESULT([$dir])
else
    AC_MSG_ERROR([cannot find zlib.h in $withval])
fi

AC_MSG_CHECKING([for libz library])

if test "$libz_dir" != "/usr"; then
    libz_ldpath="-L$libz_dir/lib"
fi

libz_libs="-lz"

save_cflags="$CFLAGS"
save_ldflags="$LDFLAGS"
save_libs="$LIBS"
CFLAGS="$CFLAGS $libz_cflags"
LDFLAGS="$LDFLAGS $libz_ldpath"
LIBS="$LIBS $libz_libs"

MYAC_CHECK_LIBZ

CFLAGS="$save_cflags"
LDFLAGS="$save_ldflags"
LIBS="$save_libs"

libz_ldflags="$libz_ldpath $libz_libs"

AC_SUBST([libz_cflags])  # add to _CFLAGS
AC_SUBST([libz_ldflags]) # add to _LDFLAGS
