#include "private.h"

const char *
wdns_rrtype_to_str(uint16_t rrtype)
{
	switch (rrtype) {
	case WDNS_TYPE_A: return ("A");
	case WDNS_TYPE_NS: return ("NS");
	case WDNS_TYPE_MD: return ("MD");
	case WDNS_TYPE_MF: return ("MF");
	case WDNS_TYPE_CNAME: return ("CNAME");
	case WDNS_TYPE_SOA: return ("SOA");
	case WDNS_TYPE_MB: return ("MB");
	case WDNS_TYPE_MG: return ("MG");
	case WDNS_TYPE_MR: return ("MR");
	case WDNS_TYPE_NULL: return ("NULL");
	case WDNS_TYPE_WKS: return ("WKS");
	case WDNS_TYPE_PTR: return ("PTR");
	case WDNS_TYPE_HINFO: return ("HINFO");
	case WDNS_TYPE_MINFO: return ("MINFO");
	case WDNS_TYPE_MX: return ("MX");
	case WDNS_TYPE_TXT: return ("TXT");
	case WDNS_TYPE_RP: return ("RP");
	case WDNS_TYPE_AFSDB: return ("AFSDB");
	case WDNS_TYPE_X25: return ("X25");
	case WDNS_TYPE_ISDN: return ("ISDN");
	case WDNS_TYPE_RT: return ("RT");
	case WDNS_TYPE_NSAP: return ("NSAP");
	case WDNS_TYPE_NSAP_PTR: return ("PTR");
	case WDNS_TYPE_SIG: return ("SIG");
	case WDNS_TYPE_KEY: return ("KEY");
	case WDNS_TYPE_PX: return ("PX");
	case WDNS_TYPE_GPOS: return ("GPOS");
	case WDNS_TYPE_AAAA: return ("AAAA");
	case WDNS_TYPE_LOC: return ("LOC");
	case WDNS_TYPE_NXT: return ("NXT");
	case WDNS_TYPE_EID: return ("EID");
	case WDNS_TYPE_NIMLOC: return ("NIMLOC");
	case WDNS_TYPE_SRV: return ("SRV");
	case WDNS_TYPE_ATMA: return ("ATMA");
	case WDNS_TYPE_NAPTR: return ("NAPTR");
	case WDNS_TYPE_KX: return ("KX");
	case WDNS_TYPE_CERT: return ("CERT");
	case WDNS_TYPE_A6: return ("A6");
	case WDNS_TYPE_DNAME: return ("DNAME");
	case WDNS_TYPE_SINK: return ("SINK");
	case WDNS_TYPE_OPT: return ("OPT");
	case WDNS_TYPE_APL: return ("APL");
	case WDNS_TYPE_DS: return ("DS");
	case WDNS_TYPE_SSHFP: return ("SSHFP");
	case WDNS_TYPE_IPSECKEY: return ("IPSECKEY");
	case WDNS_TYPE_RRSIG: return ("RRSIG");
	case WDNS_TYPE_NSEC: return ("NSEC");
	case WDNS_TYPE_DNSKEY: return ("DNSKEY");
	case WDNS_TYPE_DHCID: return ("DHCID");
	case WDNS_TYPE_NSEC3: return ("NSEC3");
	case WDNS_TYPE_NSEC3PARAM: return ("NSEC3PARAM");
	case WDNS_TYPE_HIP: return ("HIP");
	case WDNS_TYPE_NINFO: return ("NINFO");
	case WDNS_TYPE_RKEY: return ("RKEY");
	case WDNS_TYPE_SPF: return ("SPF");
	case WDNS_TYPE_TKEY: return ("TKEY");
	case WDNS_TYPE_TSIG: return ("TSIG");
	case WDNS_TYPE_IXFR: return ("IXFR");
	case WDNS_TYPE_AXFR: return ("AXFR");
	case WDNS_TYPE_MAILB: return ("MAILB");
	case WDNS_TYPE_MAILA: return ("MAILA");
	case WDNS_TYPE_ANY: return ("ANY");
	case WDNS_TYPE_TA: return ("TA");
	case WDNS_TYPE_DLV: return ("DLV");
	}

	return (NULL);
}
